diff --git a/src/main/java/net/minecraft/core/item/ItemBucket.java b/src/main/java/net/minecraft/core/item/ItemBucket.java
index 7786f940b..5c8e2672b 100644
--- a/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -36,7 +36,7 @@ public class ItemBucket extends Item
     }
 
     @Override
-	public ItemStack onItemRightClick(ItemStack stack, World world, EntityPlayer player) {
+	public ItemStack onUseItem(ItemStack stack, World world, EntityPlayer player) {
 		float f = 1.0F;
 		float f1 = player.xRotO + (player.xRot - player.xRotO) * f;
 		float f2 = player.yRotO + (player.yRot - player.yRotO) * f;
diff --git a/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
index 1e5c0b636..a69352c07 100644
--- a/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
@@ -23,7 +23,7 @@ public class ItemBucketEmpty extends Item
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         float f = 1.0F;
         float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
diff --git a/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java b/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
index 8e2f8d4d2..43c34952f 100644
--- a/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
+++ b/src/main/java/net/minecraft/core/item/ItemBucketIceCream.java
@@ -11,10 +11,10 @@ public class ItemBucketIceCream extends ItemFood {
         maxStackSize = 1;
     }
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         if (entityplayer.getHealth() < entityplayer.getMaxHealth()){
-            super.onItemRightClick(itemstack, world, entityplayer);
+            super.onUseItem(itemstack, world, entityplayer);
             return new ItemStack(Item.bucket);
         }
         return itemstack;
diff --git a/src/main/java/net/minecraft/core/item/ItemDoor.java b/src/main/java/net/minecraft/core/item/ItemDoor.java
index ae5af701a..c2db036d9 100644
--- a/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -25,7 +25,7 @@ public class ItemDoor extends Item {
     }
 
 	@Override
-	public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
diff --git a/src/main/java/net/minecraft/core/item/ItemDoorPainted.java b/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
index a03b6fdce..c283b0002 100644
--- a/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
+++ b/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
@@ -13,7 +13,7 @@ public class ItemDoorPainted extends ItemDoor{
         super(name, id, doorBottom, doorTopId);
     }
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
             blockX += side.getOffsetX();
             blockY += side.getOffsetY();
diff --git a/src/main/java/net/minecraft/core/item/ItemDye.java b/src/main/java/net/minecraft/core/item/ItemDye.java
index ef766900a..59af2e1dc 100644
--- a/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -32,7 +32,7 @@ public class ItemDye extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         if (world.getBlockId(blockX, blockY, blockZ) == Block.signPostPlanksOak.id || world.getBlockId(blockX, blockY, blockZ) == Block.signWallPlanksOak.id)
         {
diff --git a/src/main/java/net/minecraft/core/item/ItemEgg.java b/src/main/java/net/minecraft/core/item/ItemEgg.java
index f75878bd4..07f939637 100644
--- a/src/main/java/net/minecraft/core/item/ItemEgg.java
+++ b/src/main/java/net/minecraft/core/item/ItemEgg.java
@@ -22,7 +22,7 @@ public class ItemEgg
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
diff --git a/src/main/java/net/minecraft/core/item/ItemFirestriker.java b/src/main/java/net/minecraft/core/item/ItemFirestriker.java
index 08636dc7d..1b56bec82 100644
--- a/src/main/java/net/minecraft/core/item/ItemFirestriker.java
+++ b/src/main/java/net/minecraft/core/item/ItemFirestriker.java
@@ -22,7 +22,7 @@ public class ItemFirestriker extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	blockX += side.getOffsetX();
     	blockY += side.getOffsetY();
diff --git a/src/main/java/net/minecraft/core/item/ItemFishingRod.java b/src/main/java/net/minecraft/core/item/ItemFishingRod.java
index e617831de..74a2070d7 100644
--- a/src/main/java/net/minecraft/core/item/ItemFishingRod.java
+++ b/src/main/java/net/minecraft/core/item/ItemFishingRod.java
@@ -19,7 +19,7 @@ public class ItemFishingRod extends Item
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         if(entityplayer.bobberEntity != null)
         {
diff --git a/src/main/java/net/minecraft/core/item/ItemFlag.java b/src/main/java/net/minecraft/core/item/ItemFlag.java
index 74ec0a021..dcabac23f 100644
--- a/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -28,7 +28,7 @@ public class ItemFlag extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack stack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         // copy flag data to empty flag
 		if (world.getBlockId(blockX, blockY, blockZ) == Block.flag.id && !entityplayer.isSneaking()) {
diff --git a/src/main/java/net/minecraft/core/item/ItemFood.java b/src/main/java/net/minecraft/core/item/ItemFood.java
index 2868deb76..a4ff0d6c3 100644
--- a/src/main/java/net/minecraft/core/item/ItemFood.java
+++ b/src/main/java/net/minecraft/core/item/ItemFood.java
@@ -20,7 +20,7 @@ public class ItemFood extends Item
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         if(entityplayer.getHealth() < entityplayer.getMaxHealth()
                 && entityplayer.getHealth() + entityplayer.getTotalHealingRemaining() < entityplayer.getMaxHealth()
diff --git a/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java b/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
index 13f6cb549..6822ceb7c 100644
--- a/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
+++ b/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
@@ -19,7 +19,7 @@ public class ItemHandCannonLoaded extends Item
     }
 
 	@Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
 		world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3F, 1.0F / (itemRand.nextFloat() * -0.2F + -0.4F));
 
diff --git a/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java b/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
index 9319f67e6..7dc08561d 100644
--- a/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
+++ b/src/main/java/net/minecraft/core/item/ItemHandCannonUnloaded.java
@@ -18,7 +18,7 @@ public class ItemHandCannonUnloaded extends Item
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         if (entityplayer.inventory.consumeInventoryItem(Item.ammoChargeExplosive.id))
         {
diff --git a/src/main/java/net/minecraft/core/item/ItemJar.java b/src/main/java/net/minecraft/core/item/ItemJar.java
index 97620208e..bb0762fa8 100644
--- a/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/src/main/java/net/minecraft/core/item/ItemJar.java
@@ -16,7 +16,7 @@ public class ItemJar extends ItemPlaceable{
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(entityplayer,entityplayer.bb.expand(2, 2, 2));
         
diff --git a/src/main/java/net/minecraft/core/item/ItemLabel.java b/src/main/java/net/minecraft/core/item/ItemLabel.java
index 5c681a44c..d0f953fe8 100644
--- a/src/main/java/net/minecraft/core/item/ItemLabel.java
+++ b/src/main/java/net/minecraft/core/item/ItemLabel.java
@@ -11,7 +11,7 @@ public class ItemLabel extends Item
     }
 
 	@Override
-	public ItemStack onItemRightClick(final ItemStack stack, final World world, final EntityPlayer player) {
+	public ItemStack onUseItem(final ItemStack stack, final World world, final EntityPlayer player) {
 		if(stack.hasCustomName()) {
 			return stack;
 		}
diff --git a/src/main/java/net/minecraft/core/item/ItemMap.java b/src/main/java/net/minecraft/core/item/ItemMap.java
index b82cb45e3..b40c8de75 100644
--- a/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -62,7 +62,7 @@ public class ItemMap extends ItemComplex
     }
 
 	@Override
-	public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if (world.getBlockId(blockX, blockY, blockZ) == Block.flag.id) {
 			ItemMapSavedData mapData = (ItemMapSavedData)world.getSavedData(ItemMapSavedData.class, "map_" + itemstack.getMetadata());
 			TileEntityFlag flag = (TileEntityFlag) world.getBlockTileEntity(blockX, blockY, blockZ);
diff --git a/src/main/java/net/minecraft/core/item/ItemMinecart.java b/src/main/java/net/minecraft/core/item/ItemMinecart.java
index 0150f1ef7..88c497351 100644
--- a/src/main/java/net/minecraft/core/item/ItemMinecart.java
+++ b/src/main/java/net/minecraft/core/item/ItemMinecart.java
@@ -23,7 +23,7 @@ public class ItemMinecart extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int i1 = world.getBlockId(blockX, blockY, blockZ);
         if(BlockRail.isRailBlock(i1))
diff --git a/src/main/java/net/minecraft/core/item/ItemPainting.java b/src/main/java/net/minecraft/core/item/ItemPainting.java
index 1822c1bff..1ee4e066b 100644
--- a/src/main/java/net/minecraft/core/item/ItemPainting.java
+++ b/src/main/java/net/minecraft/core/item/ItemPainting.java
@@ -21,7 +21,7 @@ public class ItemPainting extends Item
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         if (!world.isClientSide && !entityplayer.isSneaking())
         {
@@ -32,7 +32,7 @@ public class ItemPainting extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	int sideHit = side.getId();
         if(sideHit == 0)
diff --git a/src/main/java/net/minecraft/core/item/ItemPebble.java b/src/main/java/net/minecraft/core/item/ItemPebble.java
index cb2ce19f0..abe1f861e 100644
--- a/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -30,7 +30,7 @@ public class ItemPebble
 
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
@@ -42,7 +42,7 @@ public class ItemPebble
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
diff --git a/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index 7b109ac42..02ce828c2 100644
--- a/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -1,11 +1,14 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 public class ItemPlaceable extends Item {
 	
 	public Block blockToPlace;
@@ -17,7 +20,7 @@ public class ItemPlaceable extends Item {
 	}
 
 	@Override
-	public boolean onItemUse(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
@@ -27,14 +30,15 @@ public class ItemPlaceable extends Item {
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
 		}
-		boolean placedInside = world.getBlock(blockX, blockY, blockZ) != null;
+		Block currentBlock = world.getBlock(blockX, blockY, blockZ);
+		boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
 
 		if(blockY < 0 || blockY >= world.getHeightBlocks()) {
 			return false;
 		}
 		if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
 			if (placedInside && !world.isClientSide){
-				world.playSoundEffect(2001, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
+				world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
 			}
 			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id)) {
 				blockToPlace.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
diff --git a/src/main/java/net/minecraft/core/item/ItemRecord.java b/src/main/java/net/minecraft/core/item/ItemRecord.java
index 92f661a18..1ed624050 100644
--- a/src/main/java/net/minecraft/core/item/ItemRecord.java
+++ b/src/main/java/net/minecraft/core/item/ItemRecord.java
@@ -26,7 +26,7 @@ public class ItemRecord extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         if(world.getBlockId(blockX, blockY, blockZ) == Block.jukebox.id && world.getBlockMetadata(blockX, blockY, blockZ) == 0)
         {
diff --git a/src/main/java/net/minecraft/core/item/ItemRope.java b/src/main/java/net/minecraft/core/item/ItemRope.java
index c78a9b665..1dc653271 100644
--- a/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -1,17 +1,20 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 public class ItemRope extends ItemPlaceable{
     public ItemRope(String name, int id, Block blockToPlace) {
         super(name, id, blockToPlace);
     }
     @Override
-    public boolean onItemUse(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(stack.stackSize <= 0) {
             return false;
         }
@@ -35,14 +38,15 @@ public class ItemRope extends ItemPlaceable{
             blockY += side.getOffsetY();
             blockZ += side.getOffsetZ();
         }
-        boolean placedInside = world.getBlock(blockX, blockY, blockZ) != null;
+        Block currentBlock = world.getBlock(blockX, blockY, blockZ);
+        boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
 
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
             return false;
         }
         if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
             if (placedInside && !world.isClientSide){
-                world.playSoundEffect(2001, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
+                world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
             }
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? 0b1000_0000 : 0)) {
                 blockToPlace.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
diff --git a/src/main/java/net/minecraft/core/item/ItemSeeds.java b/src/main/java/net/minecraft/core/item/ItemSeeds.java
index 916433ab4..3c55af613 100644
--- a/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/src/main/java/net/minecraft/core/item/ItemSeeds.java
@@ -16,7 +16,7 @@ public class ItemSeeds extends Item {
 	}
 
 	@Override
-	public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
diff --git a/src/main/java/net/minecraft/core/item/ItemSign.java b/src/main/java/net/minecraft/core/item/ItemSign.java
index 6cfd7192b..a8914be56 100644
--- a/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -23,7 +23,7 @@ public class ItemSign extends Item
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	int sideHit = side.getId();
         if(side == Side.BOTTOM)
diff --git a/src/main/java/net/minecraft/core/item/ItemSnowball.java b/src/main/java/net/minecraft/core/item/ItemSnowball.java
index ccc94d892..fd3ee37fb 100644
--- a/src/main/java/net/minecraft/core/item/ItemSnowball.java
+++ b/src/main/java/net/minecraft/core/item/ItemSnowball.java
@@ -22,7 +22,7 @@ public class ItemSnowball
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
diff --git a/src/main/java/net/minecraft/core/item/ItemSoup.java b/src/main/java/net/minecraft/core/item/ItemSoup.java
index dfc8d27bb..71c70cee6 100644
--- a/src/main/java/net/minecraft/core/item/ItemSoup.java
+++ b/src/main/java/net/minecraft/core/item/ItemSoup.java
@@ -12,9 +12,9 @@ public class ItemSoup extends ItemFood
     }
 
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
-        ItemStack stack = super.onItemRightClick(itemstack, world, entityplayer);
+        ItemStack stack = super.onUseItem(itemstack, world, entityplayer);
         return stack.stackSize <= 0 ? Item.bowl.getDefaultStack() : stack;
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemStack.java b/src/main/java/net/minecraft/core/item/ItemStack.java
index c2b3ae546..7d52537c1 100644
--- a/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -117,7 +117,7 @@ public final class ItemStack
 
     public boolean useItem(EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
-        boolean flag = getItem().onItemUse(this, entityplayer, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+        boolean flag = getItem().onUseItemOnBlock(this, entityplayer, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
         if(flag)
         {
             entityplayer.addStat(StatList.usedItemStats[itemID], 1);
@@ -132,7 +132,7 @@ public final class ItemStack
 
     public ItemStack useItemRightClick(World world, EntityPlayer entityplayer)
     {
-        return getItem().onItemRightClick(this, world, entityplayer);
+        return getItem().onUseItem(this, world, entityplayer);
     }
 
 	public CompoundTag writeToNBT(CompoundTag nbt) {
diff --git a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 937bf320c..f6abf76b3 100644
--- a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -23,7 +23,7 @@ public class ItemWandSpawner
         super(name, id);
     }
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer player)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer player)
     {
         if (player.gamemode != Gamemode.creative){
             player.sendTranslatedChatMessage("wand.wrongmode");
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index d6b8aa628..6489ee451 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
@@ -8,6 +9,8 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, World, ItemStack, 
 //            Material, StepSound, EntityPlayer
@@ -30,7 +33,7 @@ public class ItemBlock extends Item
     }
 
     @Override
-	public boolean onItemUse(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
@@ -39,14 +42,16 @@ public class ItemBlock extends Item
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
 		}
-        boolean placedInside = world.getBlock(blockX, blockY, blockZ) != null;
+        Block currentBlock = world.getBlock(blockX, blockY, blockZ);
+        boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
+
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
         	return false;
         }
 		if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
 			Block block = Block.blocksList[blockID];
             if (placedInside && !world.isClientSide){
-                world.playSoundEffect(2001, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
+                world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
             }
 			if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(stack.getMetadata()))) {
 				block.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index 2b506bf17..fa0e47a1a 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -25,13 +25,13 @@ public class ItemBlockAlgae extends ItemBlock
     }
     
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	return false;
     }
     
     @Override
-    public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
     {
         float f = 1.0F;
         float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index ef2e9ddad..4fde46643 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.block.BlockLadder;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -8,6 +9,8 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 public class ItemBlockLadder extends ItemBlock {
 
 	private BlockLadder blockLadder;
@@ -19,7 +22,7 @@ public class ItemBlockLadder extends ItemBlock {
 	}
 	
 	@Override
-	public boolean onItemUse(ItemStack stack, EntityPlayer player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		Block clickedBlock = world.getBlock(x, y, z);
 		
 		if(clickedBlock == blockLadder && !player.isSneaking()) {
@@ -55,8 +58,8 @@ public class ItemBlockLadder extends ItemBlock {
 	public boolean placeBlock(World world, int x, int y, int z, int meta, EntityPlayer player, ItemStack stack, Side side, double sideHeight) {
 		Block currentBlock = world.getBlock(x, y, z);
 		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
-			if (currentBlock != null && !world.isClientSide){
-				world.playSoundEffect(2001, x, y, z, world.getBlockId(x, y, z));
+			if (currentBlock != null && !(currentBlock instanceof BlockFluid) && !world.isClientSide){
+				world.playSoundEffect(EVENT_BLOCK_BREAK, x, y, z, world.getBlockId(x, y, z));
 			}
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
 				Block.getBlock(blockID).onBlockPlaced(world, x, y, z, side, player, sideHeight);
